IfTest := UnitTest clone do(

    setUp := method(
    )

    /*
    Object if := method(condition,
        index = if(condition, 1, 2)
        if(call message arguments size > index,
            call sender doMessage(call message argAt(index), call sender)
        ,
            if(condition, true, false)
        )
    )
    */

    testIfEval := method(
        IfTest v := false
        if(IfTest v := true)
        assertTrue(v)
    )

    testTrue := method(
        assertTrue(if(true))
    )

    testTrueExpression := method(
        assertEquals(if(true, 1), 1)
    )

    testTrue2Expressions := method(
        assertEquals(if(true, 1, 2), 1)
    )

    testFalse := method(
        assertFalse(if(false))
    )

    testFalseExpression := method(
        assertFalse(if(false, 1))
    )

    testFalse2Expressions := method(
        assertEquals(if(false, 1, 2), 2)
    )

    testNil := method(
        assertFalse(if)
        assertFalse(if())
        assertFalse(if(nil))
    )

    testOtherTrue := method(
        assertTrue(if(Object))
        assertTrue(if(13))
        assertTrue(if("foo"))
    )

    testThenTrue := method(
        self v := false
        assertNil(true then(IfTest v := true))
        assertTrue(v)
    )

    testThenFalse := method(
        self v := false
        assertFalse(false then(IfTest v := true))
        assertFalse(v)
    )

    testThenNil := method(
        self v := false
        assertNil(nil then(IfTest v := true))
        assertFalse(v)
    )

    testElseTrue := method(
        self v := false
        assertTrue(true else(IfTest v := true))
        assertFalse(v)
    )

    testElseFalse := method(
        self v := false
        assertNil(false else(IfTest v := true))
        assertTrue(v)
    )

    testElseNil := method(
        self v := false
        assertNil(nil else(IfTest v := true))
        assertFalse(v)
    )

    testElseIfTrueTrue := method(
        self v := false
        assertTrue(true elseif(IfTest v := true; true))
        assertFalse(v)
    )

    testElseIfTrueFalse := method(
        self v := false
        assertTrue(true elseif(IfTest v := true; false))
        assertFalse(v)
    )

    testElseIfFalseTrue := method(
        self v := false
        assertTrue(false elseif(IfTest v := true; true))
        assertTrue(v)
    )

    testElseIfFalseFalse := method(
        self v := false
        assertFalse(false elseif(IfTest v := true; false))
        assertTrue(v)
    )

    testElseIfNilTrue := method(
        self v := false
        assertNil(nil elseif(IfTest v := true; true))
        assertFalse(v)
    )

    testElseIfNilFalse := method(
        self v := false
        assertNil(nil elseif(IfTest v := true; false))
        assertFalse(v)
    )
)
