Binding clone do(
	if(list("cygwin") contains(platform),
		dependsOnLib("glu32")
		dependsOnLib("opengl32")
        )
	if(list("windows") contains(platform),
		dependsOnSysLib("glu32")
		dependsOnSysLib("opengl32")
	)

	if(platform == "darwin",
		dependsOnFramework("OpenGL")
	)

	if(platform == "linux",
		dependsOnLib("GL")
		dependsOnLib("GLU")
	)

	if (platform != "darwin",
		dependsOnHeader("zlib.h")
        )
	if (platform != "darwin" and platform != "windows",
		dependsOnHeader("GL/gl.h")
		dependsOnHeader("GL/glu.h")
	)

	dependsOnLib("z")
	dependsOnLib("png")
	dependsOnLib("tiff")
	dependsOnLib("jpeg")

	dependsOnHeader("png.h")
	dependsOnHeader("tiff.h")
	dependsOnHeader("jpeglib.h")

	debs atPut("png", "libpng12-dev")
	ports atPut("png", "libpng")
	ebuilds atPut("png", "libpng")

	debs atPut("tiff", "libtiff4-dev")
	ports atPut("tiff", "tiff")
	ebuilds atPut("tiff", "tiff")

	debs atPut("jpeg", "libjpeg62-dev")
	ports atPut("jpeg", "jpeg")
	ebuilds atPut("jpeg", "jpeg")
)
