Binding clone do(
	if(list("cygwin") contains(platform),
		dependsOnLib("winmm")
		dependsOnLib("glu32")
		dependsOnLib("glut32")
		dependsOnLib("opengl32")
	)

	if(list("windows") contains(platform),
		dependsOnSysLib("glut32")
		dependsOnSysLib("opengl32")
	)

	if(platform == "darwin",
		dependsOnFramework("GLUT")
		dependsOnFramework("OpenGL")
		dependsOnFramework("Carbon")
		dependsOnFramework("Foundation")
	)

	if(list("linux", "netbsd") contains(platform),
		dependsOnLib("GL")
		dependsOnLib("GLU")
		dependsOnLib("glut")
	)

	if (platform != "darwin" and platform != "windows",
		dependsOnHeader("GL/gl.h")
		dependsOnHeader("GL/glu.h")
		dependsOnHeader("GL/glut.h")
	)

	dependsOnBinding("Vector")
	dependsOnBinding("Image")

	debs atPut("GL", "libgl1-mesa-dev")
	ebuilds atPut("GL", "mesa")

	debs atPut("GLU", "libglu1-mesa-dev")
	ebuilds atPut("GLU", "mesa")

	debs atPut("glut", "freeglut3-dev")
	ports atPut("glut", "glut")
	ebuilds atPut("glut", "media-libs/glut")
)
